diff -ru PyWebDAV-0.9~/DAV/WebDAVServer.py PyWebDAV-0.9/DAV/WebDAVServer.py
--- PyWebDAV-0.9~/DAV/WebDAVServer.py	2009-05-06 18:57:08.000000000 +0200
+++ PyWebDAV-0.9/DAV/WebDAVServer.py	2009-05-06 23:18:30.000000000 +0200
@@ -296,6 +296,49 @@
         dc=self.IFACE_CLASS
         uri=urlparse.urljoin(self.get_baseuri(dc), self.path)
         uri=urllib.unquote(uri)
+
+        # Handle If-Match
+        if self.headers.has_key('If-Match'):
+            test = False
+            etag = None
+            try:
+                etag = dc.get_prop(uri, "DAV:", "getetag")
+            except:
+                pass
+            for match in self.headers['If-Match'].split(','):
+                if match == '*':
+                    if dc.exists(uri):
+                        test = True
+                        break
+                else:
+                    if match == etag:
+                        test = True
+                        break
+            if not test:
+                self.send_status(412)
+                return
+
+        # Handle If-None-Match
+        if self.headers.has_key('If-None-Match'):
+            test = True
+            etag = None
+            try:
+                etag = dc.get_prop(uri, "DAV:", "getetag")
+            except:
+                pass
+            for match in self.headers['If-None-Match'].split(','):
+                if match == '*':
+                    if dc.exists(uri):
+                        test = False
+                        break
+                else:
+                    if match == etag:
+                        test = False
+                        break
+            if not test:
+                self.send_status(412)
+                return
+
         dl=DELETE(uri,dc)
         if dc.is_collection(uri):
             res=dl.delcol()
@@ -310,6 +353,48 @@
     def do_PUT(self):
         dc=self.IFACE_CLASS
 
+        # Handle If-Match
+        if self.headers.has_key('If-Match'):
+            test = False
+            etag = None
+            try:
+                etag = dc.get_prop(uri, "DAV:", "getetag")
+            except:
+                pass
+            for match in self.headers['If-Match'].split(','):
+                if match == '*':
+                    if dc.exists(uri):
+                        test = True
+                        break
+                else:
+                    if match == etag:
+                        test = True
+                        break
+            if not test:
+                self.send_status(412)
+                return
+
+        # Handle If-None-Match
+        if self.headers.has_key('If-None-Match'):
+            test = True
+            etag = None
+            try:
+                etag = dc.get_prop(uri, "DAV:", "getetag")
+            except:
+                pass
+            for match in self.headers['If-None-Match'].split(','):
+                if match == '*':
+                    if dc.exists(uri):
+                        test = False
+                        break
+                else:
+                    if match == etag:
+                        test = False
+                        break
+            if not test:
+                self.send_status(412)
+                return
+
         # Handle expect
         expect = self.headers.get('Expect', '')
         if (expect.lower() == '100-continue' and
